#include <stdio.h>
#include <stdlib.h>

struct node {
   int data;
   struct node *left_child;
   struct node *right_child;
};
typedef struct node treenode;
typedef treenode *tree_ptr;

void insert_node (tree_ptr head, int key);
void delete_node (tree_ptr head, int key);
tree_ptr search_node (tree_ptr head, int key);

main()
{
   tree_ptr ptr, temp;
   int select, data;

   while (1) {
      printf("select menu : 1.insert 2.delete 3.search 4.exit => ");
      scanf("%d", &select);
      if (select == 1) {
         printf("insert data => ");
         scanf("%d", &data);
         insert_node (ptr, data);
      } else if (select == 2) {
         printf("delete data => ");
         scanf("%d", &data);
         delete_node (ptr, data);
      } else if (select == 3) {
         printf("search data => ");
         scanf("%d", &data);
         if (temp = search_node (ptr, data))
            printf("%d\n", temp->data);
      } else if (select == 4) {
         break;
      } else {
         printf("select error\n");
      }
   }
}

void insert_node (tree_ptr head, int key)
{
   tree_ptr ptr, temp;
   ptr = head;
   temp = ptr->right_child;
   while (temp) {
      ptr = temp;
      if (key == temp->data)
         return;
      else if (key < temp->data)
         temp = temp->left_child;
      else
         temp = temp->right_child;
   }
   temp = (tree_ptr)malloc(sizeof(treenode));
   temp->data = key;
   temp->left_child = NULL;
   temp->right_child = NULL;
   if (key < ptr->data)
      ptr->left_child = temp;
   else
      ptr->right_child = temp;
}

void delete_node (tree_ptr head, int key)
{
   tree_ptr parent, son, temp1, temp2;
   parent = head;
   son = head->right_child;
   while (son!=NULL && son->data!=key) {
      parent = son;
      if (key < son->data)
         son = son->left_child;
      else
         son = son->right_child;
   }
   if (son==NULL) {
      printf("Not found\n");
      return;
   } else
      temp1 = son;

   if (temp1->right_child==NULL && temp1->left_child==NULL)
      son = NULL;
   else if (temp1->right_child==NULL)
      son = temp1->left_child;
   else if (temp1->right_child->left_child == NULL) {
      son = temp1->right_child;
      son->left_child = temp1->left_child;
   } else {
      temp2 = son->right_child;
      while (temp2->left_child->left_child != NULL)
         temp2 = temp2->left_child;
      son = temp2->left_child;
      temp2->left_child = son->right_child;
      son->left_child = temp1->left_child;
      son->right_child = temp1->right_child;
   }
   free(temp1);
   if (key < parent->data)
      parent->left_child = son;
   else 
      parent->right_child = son;
}

tree_ptr search_node (tree_ptr head, int key)
{
   tree_ptr temp;
   temp = head;
   while (temp) {
      if (key == temp->data)
         return temp;
      if (key < temp->data)
         temp = temp->left_child;
      else
         temp = temp->right_child;
   }
   printf("Not found\n");
   return NULL;
}
